
type Representable = string|number|boolean;

type ToQueryStringA = {
    [name:string]:Representable|Representable[]
};

export const toQueryString = (obj:ToQueryStringA)=> {
    return Object.entries(obj).map(e => 
        e[1] instanceof Array 
            ? e[1].map(f=>`${e[0]}[]=${encodeURIComponent(f)}`).join('&') 
            : `${e[0]}=${encodeURIComponent(e[1])}`)
        .join('&');
}