

export function ParseQueryNumber(s: string|undefined): number| undefined{
    if(s === undefined) return undefined;
    else return Number.parseInt(s);
}
export function ParseQueryArray(s: string[]|string|undefined){
    s = s || [];
    return s instanceof Array ? s : [s];
}
export function ParseQueryBoolean(s: string|undefined): [boolean,boolean|undefined]{
    let value:boolean|undefined;
    if(s === "true")
        value = true;
    else if(s === "false")
        value = false;
    else if(s === undefined)
        value = undefined;
    else
        return [false,undefined]
    return [true,value]
}